///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//////////////////////                         ////////////////////////
//////////////////////      Task Creation      ////////////////////////
//////////////////////                         ////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <string.h>
#include <avr/eeprom.h> 
#include <avr/io.h>



//	Scheduler include files.
#include "FreeRTOS.h"
#include "task.h"

//	Other file headers. 
#include "robotTasks.h"
#include "bbot.h"
#include "twi.h"

//  external routine prototypes
extern void Init_Hdw(void);
extern void Init_Pwm(void);
extern void Read_Sensors(void);

//	Priority definitions for the tasks  
#define WaitForStart_TASK_PRIORITY	( tskIDLE_PRIORITY + 0 )

//	The tasks
extern void WaitForStart(void *pvParameters);




portSHORT main(void) {
	
	Init_Hdw();
	Init_Pwm();
	initialize_twi();

	ReadIMU = FALSE;					//	make sure off until ready
	
	TaskStackSize = configMINIMAL_STACK_SIZE + stackSize_Param;		//	number of variables (16 bits each??)
	
	xTaskCreate(WaitForStart, "Wait", TaskStackSize, NULL, WaitForStart_TASK_PRIORITY, NULL);

	vTaskStartScheduler();				//  preemptive scheduler defined

	return 0;
}




///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////



