#ifndef	__Globals_h
#define	__Globals_h
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//////////////////////                         ////////////////////////
//////////////////////     GLOBALS  Header     ////////////////////////
//////////////////////                         ////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

#include 			"FreeRTOS.h"
#include			"task.h"
#include 			"semphr.h"


///////////////////////////////////////////////////////////////////////

typedef unsigned char 	bool;
typedef unsigned char	BYTE;		// 1 byte
typedef char			CHAR; 		// 1 byte - signed
typedef int             INT16;    	// 2 or 4 byte int depending upon compile
typedef unsigned int    UINT16;   	// 2 bytes
typedef unsigned short	WORD;		// 2 bytes - default
typedef unsigned long	DWORD;		// 4 bytes - default

///////////////////////////////////////////////////////////////////////

#define		ON		1
#define 	OFF		0
#define		TRUE	1
#define		FALSE	0


#define 	PROG_LED 	_BV(PB4)      		// Output

#define		AD_C4		0x04				// ADC4 input
#define		AD_C5		0x05				// ADC5 input


#define		SENSE_LINER	0x01
#define		SENSE_LINEL	0x02
#define		SENSE_DISTR	0x04
#define		SENSE_DISTL	0x08

#define 	LEFT_MOTOR_PWM  	_BV(PD4)         // OCR1B output
#define 	RIGHT_MOTOR_PWM 	_BV(PD5)         // OCR1A output
#define 	RIGHT_MOTOR_DIR 	_BV(PC7)         // Output
#define 	LEFT_MOTOR_DIR  	_BV(PC6)         // Input
#define 	LEFT_PWM  			OCR1B
#define 	RIGHT_PWM 			OCR1A

//---Sensor settings-------

#define		AD_LINEL			0x01
#define		AD_LINER			0x03
#define    	AD_DISTR        	0x07
#define		AD_DISTL         	0x00
#define		DIST_CLOSE			25


#define		START_SW			0x02			// switch bit mask


///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//
//	Sensing
extern unsigned char 		AD_Comp;		//  for ADC
extern unsigned char 		Sense_Stat;
extern unsigned int			Rem_Value;		//	for ADC
extern unsigned int			Lsense_Val;
extern unsigned int			Rsense_Val;
extern unsigned int  		LDsense_Val;
extern unsigned int  		RDsense_Val;
extern unsigned int			Object_found;

extern unsigned int 		ADC4_Val;		//
extern unsigned int 		ADC5_Val;		//

extern unsigned char		Forward_Sensor_Latch;
extern unsigned char		Rear_Sensor_Latch;
//
///////////////////////////////////////////////////////////////////////

//
//	General
extern	unsigned int		TaskStackSize;
extern	bool	 			ReadIMU;
extern	bool				LED_ON;
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
#endif
