///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//////////////////////                         ////////////////////////
//////////////////////           LCD           ////////////////////////
//////////////////////                         ////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//
#include "parameters.h"
//
//
#ifdef TXT_LCD
//
// The LCD I2C address is 0x50 if left-shifted 1 and combined with the r/~w bit
// The TWI functions used here handle the r/~w bit for us, depending on the function
#define TWI_LCD_ADDR 0x28

#define lcd_print(str) TWI_write(TWI_LCD_ADDR, str, strlen(str))

#define lcd_prints(str) TWI_write(TWI_LCD_ADDR, str, sizeof(str) - 1)

#define lcd_write_byte(data) TWI_write(TWI_LCD_ADDR, data, 1)

#define lcd_clear() TWI_write(TWI_LCD_ADDR, "\x0C", 1); //clear display, return cursor to top left
#define lcd_cr() 	TWI_write(TWI_LCD_ADDR, "\x0D", 1); //carriage return, cursor to beginning of line
#define lcd_lf() 	TWI_write(TWI_LCD_ADDR, "\x0A", 1); //linefeed, cursor to beiginning of next line
#define lcd_bs() 	TWI_write(TWI_LCD_ADDR, "\x08", 1); //backspace, moves cursor one to left and clears current

#define lcd_initBarGraph() TWI_write(TWI_LCD_ADDR, "\xFE\x68",2) 
#define lcd_drawBarGraph() TWI_write(TWI_LCD_ADDR, "\xFE\x7C",2) // must follow with [col][row][dir][len]

#define lcd_readkeys(ch) TWI_read(TWI_LCD_ADDR, ch, 1);
//
#endif






#ifdef GRH_LCD
//
// The LCD I2C address is 0x50 if left-shifted 1 and combined with the r/~w bit
// The TWI functions used here handle the r/~w bit for us, depending on the function
#define TWI_LCD_ADDR 0x28
//
#define lcd_clear() TWI_write(TWI_LCD_ADDR, "\xFE\x58", 2); //clear display, return cursor to top left
//
//
#endif

