///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//////////////////////                         ////////////////////////
//////////////////////     Common Routines     ////////////////////////
//////////////////////                         ////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <math.h>
#include <inttypes.h>
#include "Routines.h"
#include "bbot.h"
#include "robotTasks.h"
#include "FreeRTOS.h"
#include "task.h"
#include "Globals.h"

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////



float scale_accel(int rawAccel)
{
	// at some point in time, switch to a more delayed conversion to float
	// no float needed until later, unless averaging!

//	float accel	= (float) rawAccel - ACCEL_OFFSET;
	// limit to prevent noise from causing a call to asin outside [-1,1]
//	accel = flim(accel, -ACCEL_SCALE, ACCEL_SCALE);
//return 0;

  	float accel;
	float temp;
	temp = (float) rawAccel - ACCEL_OFFSET;
	//accel = flim(temp, -ACCEL_SCALE, ACCEL_SCALE);
	accel = temp;
	if (accel < -ACCEL_SCALE) accel = -ACCEL_SCALE;
	if (accel > ACCEL_SCALE)  accel =  ACCEL_SCALE;


	// convert accel into an angle, using asin (ACCEL_SCALE = 1 g)
	// returned result will be in range [-pi/2,pi/2], radians
//	float temp = accel / ACCEL_SCALE;


	temp = accel / ACCEL_SCALE;
	
	accel = asin(temp);	
	
	//accel = asin(accel / ACCEL_SCALE);
	// finally, convert to human-readable form : degrees
	accel *= RAD_TO_DEG;
	return accel;
}

//--------------------------------------------------------------------------------------------------------------------
float scale_gyro(int rawGyro)
{
	float gyro = (float) rawGyro - GYRO_OFFSET;
	
	//gyro *= (100.0);
	gyro *= GYRO_SCALE;
	return gyro;
}

//--------------------------------------------------------------------------------------------------------------------
int avg(int array[], int n)
{
	int i;
	int sum = 0;
	for (i = 0; i < n; i++)
		sum += array[i];
	return sum / n;
}

//--------------------------------------------------------------------------------------------------------------------
float favg(unsigned int array[], int n)
{
	int i;
	uint32_t sum = 0;
	for (i = 0; i < n; i++) 
		sum += array[i];
	return ((float) sum) / n;
}

//--------------------------------------------------------------------------------------------------------------------
float fmax(float a, float b)
{
  if (a>=b) {
    return a;
  } else {
    return b;
  }
}

//--------------------------------------------------------------------------------------------------------------------
float fmin(float a, float b)
{
  if (a<=b) {
    return a;
  } else {
    return b;
  }
}

//--------------------------------------------------------------------------------------------------------------------
float flim(float x, float lo, float hi)
{
  if (x>hi) return hi;
  if (x<lo) return lo;
  return x;
}


//--------------------------------------------------------------------------------------------------------------------
void Init_Queues_Semaphores() {

}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
